#include "xbgi.ph" 

program Mandelbrot(input, output);

import BgiGraphics; { entspricht zusammen mit obiger
			#include Anweisung "uses graph.tpu" }

const
     maxiter=40;
     zerr=1.2;
     maxx = 640;
     maxy = 480;
     g0 = 4;  c0 = 14; 
     g1 = 5;  c1 = 1; 
     g2 = 6;  c2 = 3; 
     g3 = 7;  c3 = 5; 
     g4 = 8;  c4 = 9; 
     g5 = 10; c5 = 11; 
     g6 = 17; c6 = 4; 
              c7 = 14;

var
   fl,rl,rr,io,xc,yc : real;
   spa,zei,k : integer;
   graphmode, graphdriver, error : integer;
   dummy :  packed array [ 1..255 ] of char;

procedure iteration (xc,yc : real; max: integer; var K : integer);
var x, y, x2, y2, r, s : real;
begin
     x:=0; y:=0; x2:=0; y2:=0; k:=0;
     r:=sqr(xc)+sqr(yc); s:=sqrt(r-0.5*xc+0.0625);
     if (16*r*s>5*s-4*xc+1) and (sqr(xc+1)+sqr(yc)>0.0625) then
     while (x2+y2<=4) and (k<max) do begin
           y:=2*x*y+yc; x:=x2-y2+xc;
           x2:=sqr(x); y2:=sqr(y); k:=succ(k)
     end
     else k:=max
end;

begin
     detectgraph(graphdriver,graphmode); { graphdriver:=detect; geht 
nicht mehr, liese sich aber nachru^sten }
     initgraph(graphdriver,graphmode,dummy); { der dritte (leer) Paramter 
muss formal korrekt sein. }
     setcolor(0); { Damit das Workaround in putpixel.c richtig funktioniert 
}
     rl:=-2.2657; rr:=1.0; io:=1.3;
     fl:=(rr-rl)/maxx;
     yc:=io;
     for zei:=0 to maxy do
     begin
          xc:=rl;
          for spa:=0 to maxx do
          begin
               iteration(xc,yc,maxiter,k);
               if ((k<g0) or (k=maxiter)) then
               else if k<g1 then putpixel(spa,zei,c1)
               else if k<g2 then putpixel(spa,zei,c2)
               else if k<g3 then putpixel(spa,zei,c3)
               else if k<g4 then putpixel(spa,zei,c4)
               else if k<g5 then putpixel(spa,zei,c5)
               else if k<g6 then putpixel(spa,zei,c6)
               else putpixel(spa,zei,c7);
               xc:=xc+fl;
          end;
          yc:=yc-fl*zerr
     end;
     repeat
     until (keypressed<>0); { nur "until keypressed" geht leider nicht }
     closegraph;
end.
